#include "ConfigurationService.h"
#include "Configuration.h"

namespace tncfhh {

std::vector<std::pair<std::string,std::string> > ConfigurationService::readConfiguration() {

	std::ifstream file;
	char buffer[1024];

	std::string filename = Configuration::instance()->get("CONFIGURATION_SERVICE_FILE");
	file.open(filename.c_str(), std::ios::in);

	if (file.good()) {
		file.seekg(0L, std::ios::beg);

		while (!file.eof()) {
			file.getline(buffer, 1024);
			std::string line = std::string(buffer);

			/* ignore comments */
			if (line.size()<1 || line.at(0)=='#')
				continue;

			size_t pos = line.find_first_of('=');

			/* ignore illegal lines */
			if (pos == std::string::npos) {
				continue;
			}

			/* get key */
			std::string key = line.substr(0, pos);

			/* get value */
			std::string value = line.substr(pos + 1, line.size());

	        /* add key-value-pair */
			properties.push_back(std::pair<std::string, std::string>(key, value));

		}
	}
	else {
		std::cout << "File not found!" << std::endl;
	}
    return properties;
}

}
